//NIR_Lampa_PE_2024
//Zdrojový kód NIR_Lampa pre konkurz PE2024
//Milan Mikšovský, 24.08.2024
//GPL
//Projekt zaberá 1962 bytov (95%) pamäte pre program. Maximum je 2048 bytov.
//Globálne premenné zaberajú 33 bytov (25%)  dynamickej pamäti, 
//95 bytov zostáva pre lokálne premenné. Maximum je 128 bytov.
//Tiny25
#include <ATTinyCore.h>

int cas_on = 120;
int tlacitko = 0;
bool TL1 = false, TL2 = false, TL3 = false;
int prerus = 1;
long int casoff = 0;

void TL123();
void TL_stlacene(bool stav);
void blik_Rada123(int pin);
void jasRada123();
void setup() {
  pinMode(0, OUTPUT);
  pinMode(1, OUTPUT);
  pinMode(2, OUTPUT);
  pinMode(4, OUTPUT); // zvuk
  tone(4, 1568);delay(150);noTone(4);
}

void TL123() {
  tlacitko = analogRead(A3);
  TL1 = (tlacitko <= 20);
  TL2 = (tlacitko >= 505 && tlacitko <= 515);
  TL3 = (tlacitko >= 675 && tlacitko <= 685);
}

void blik_Rada123(int pin) {
  digitalWrite(pin, HIGH);
  delay(cas_on);
  digitalWrite(pin, LOW);
  delay(cas_on / 8);
}

void jasRada123() {
  if (TL1) {
    cas_on -= 15;
    if (cas_on <= 5) cas_on = 5;
  } 
  if (TL3) {
    cas_on += 15;
    if (cas_on >= 135) {
      cas_on = 135;
      prerus = 1;
      sviet_5x1min();
      tone(4, 1047);delay(50);tone(4, 1319);delay(50);tone(4, 1760);delay(50);noTone(4);
    }
  } 
  if (TL2) {
    cas_on = 120;
  } 
}

void blik_vpravo_vlavo() {
  for (int i = 0; i < 10; i++) {
    TL123();
    blik_Rada123(0);
    jasRada123();
    TL123();
    blik_Rada123(1);
    jasRada123();
    TL123();
    blik_Rada123(2);
    jasRada123();
  }
  for (int i = 0; i < 10; i++) {
    TL123();
    blik_Rada123(2);
    jasRada123();
    TL123();
    blik_Rada123(1);
    jasRada123();
    TL123();
    blik_Rada123(0);
    jasRada123();
  }
}

void sviet_zhasni_Rada123(bool stav) {
  digitalWrite(0, stav);
  digitalWrite(1, stav);
  digitalWrite(2, stav);
}

void sviet_5x1min() {
  int minut5 = 310 * 5;
  casoff = 0;
  while (prerus) {
    TL123();
    sviet_zhasni_Rada123(HIGH);
    if (TL2) {
      sviet_zhasni_Rada123(LOW);
      prerus = 0;
      cas_on = 120;
    }
    if (casoff >= minut5) {
      casoff = 0;
      sviet_zhasni_Rada123(LOW);
      prerus = 0;
      cas_on = 135;
    }
    casoff++;
    delay(24);  //5 -< 1min,  24=5min
  }
  //tone(4, 1500);noTone(4);delay(150);
}

void loop() {
  blik_vpravo_vlavo();
}
